VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CEventTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Pass object number from Form level variable to
'to Class for debugging purposes
Public Event PercentDone(ByVal Percent As Single, _
    ByRef lbCancel As Boolean, ByRef aiNum As Integer)

Public Sub LongTask(ByVal afDuration As Single, _
    ByVal afMinInterval As Single)
    
    Dim lfThreshold As Single
    Dim lfStart     As Single
    Dim lbCancel    As Boolean
    Dim liNumObj    As Integer
    Dim liCount     As Integer
    
    'Use the VB timer function, returns
    'number of seconds since midnight
    lfStart = Timer
    lfThreshold = afMinInterval
    
    'Also force minimum number of calls, not
    'strictly based on elapsed time
    Do While Timer < (lfStart + afDuration) Or liCount < 5
         If Timer > (lfStart + lfThreshold) Then
            RaiseEvent PercentDone(lfThreshold / afDuration, _
                lbCancel, liNumObj)
            
            'Check to see if the operation was Canceled.
            If lbCancel Then Exit Sub
            
            'Count number of times Event has been raised
            liCount = liCount + 1
            
            'Show which object we are
            Debug.Print "LongTask" & liCount & _
                " from object # " & liNumObj
            
            lfThreshold = lfThreshold + afMinInterval
         End If
    Loop

End Sub


