VERSION 5.00
Begin VB.Form frmEvent4_3 
   Caption         =   "User-Defined Event Test"
   ClientHeight    =   1065
   ClientLeft      =   2610
   ClientTop       =   600
   ClientWidth     =   4920
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1065
   ScaleWidth      =   4920
   Begin VB.CommandButton cmdFont 
      Caption         =   "Font Size"
      Height          =   435
      Left            =   4200
      TabIndex        =   4
      ToolTipText     =   "Cancel a running task"
      Top             =   540
      Width           =   555
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Enabled         =   0   'False
      Height          =   435
      Left            =   1500
      TabIndex        =   1
      ToolTipText     =   "Cancel a running task"
      Top             =   540
      Width           =   1035
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "&Go"
      Default         =   -1  'True
      Height          =   435
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Start the task"
      Top             =   540
      Width           =   1035
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   435
      Left            =   2880
      TabIndex        =   2
      ToolTipText     =   "Terminate the application"
      Top             =   540
      Width           =   1035
   End
   Begin VB.Label lblPercentDone 
      Alignment       =   2  'Center
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Top             =   120
      Width           =   2475
   End
End
Attribute VB_Name = "frmEvent4_3"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Based on Warren Bedell's Test4 Event example

'Third attempt at modification to handle multiple objects
'Changed logic in class module so that LongTask also based
'        on at least 5 Event calls

Option Explicit

Private WithEvents foTest    As CEventTest
Attribute foTest.VB_VarHelpID = -1
Private fbCancel             As Boolean
Private fiNum                As Integer

Public Sub Display(ByVal aiNum As Integer)
    
    'Identify which object # this form will create
    fiNum = aiNum
    
    'Display the form with modified caption
    Me.Caption = "Event4_3: Object number " + CStr(fiNum)
    
    'Change location so you can see each one
    Me.Top = Me.Top + 1500 * fiNum
    Me.Left = Me.Left + 500 * fiNum
    Me.Show vbModeless
    
End Sub

Private Sub cmdCancel_Click()

    fbCancel = True

End Sub

Private Sub cmdExit_Click()

    Unload Me

End Sub

Private Sub cmdGo_Click()

    fbCancel = False
    lblPercentDone.Caption = "0%"
    
    DoEvents

    Me.MousePointer = vbArrowHourglass
    cmdCancel.Enabled = True
    cmdGo.Enabled = False
    cmdExit.Enabled = False
    DoEvents

    'Start a long running process in
    'the class module
    
    foTest.LongTask 5, 0.5

    cmdExit.Enabled = True
    cmdGo.Enabled = True
    cmdCancel.Enabled = False
    Me.MousePointer = vbDefault
    DoEvents

    If Not fbCancel Then
        lblPercentDone.Caption = "Done"
    Else
        lblPercentDone.Caption = "Canceled"
    End If

End Sub

Private Sub foTest_PercentDone(ByVal afPercent As Single, _
    abCancel As Boolean, aiNum As Integer)

    'This event is raised by the CEventText
    'class, which returns the Percent value,
    'which we display
    
    'We also pass the value of Cancel back to
    'the class in the second argument. This will
    'be true if we press the Cancel button
    
    lblPercentDone.Caption = CInt(100 * afPercent) & "%"

    DoEvents

    abCancel = fbCancel

    'Pass object number from Form level variable to
    'to Class for debugging purposes
    aiNum = fiNum
    
End Sub

Private Sub Form_Terminate()

    Set foTest = Nothing

End Sub

Private Sub Form_Initialize()
    
    Set foTest = New CEventTest

End Sub

Private Sub cmdFont_Click()

    Call ChgFontSize(Me)

End Sub


